Package org.htmlunit.html

# Class HtmlObject

java.lang.Object
org.htmlunit.html.DomNode
org.htmlunit.html.DomNamespaceNode
org.htmlunit.html.DomElement
org.htmlunit.html.HtmlElement
org.htmlunit.html.HtmlObject

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `ValidatableElement`, `Element`, `Node`

public class HtmlObject extends HtmlElement implements ValidatableElement
Wrapper for the HTML element "object".

See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.htmlunit.html.HtmlElement

  `HtmlElement.DisplayStyle`

  ## Nested classes/interfaces inherited from class org.htmlunit.html.DomElement

  `DomElement.ChildElementsIterator`

  ## Nested classes/interfaces inherited from class org.htmlunit.html.DomNode

  `DomNode.ChildIterator, DomNode.DescendantDomElementsIterator, DomNode.DescendantDomNodesIterator, DomNode.DescendantElementsIterator<T extends DomNode>, DomNode.DescendantHtmlElementsIterator`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `TAG_NAME`
  The HTML tag represented by this element.

  ### Fields inherited from class org.htmlunit.html.HtmlElement

  `ATTRIBUTE_CHECKED, ATTRIBUTE_HIDDEN, ATTRIBUTE_REQUIRED, TAB_INDEX_OUT_OF_BOUNDS`

  ### Fields inherited from class org.htmlunit.html.DomElement

  `ATTRIBUTE_NOT_DEFINED, ATTRIBUTE_VALUE_EMPTY, ID_ATTRIBUTE, NAME_ATTRIBUTE, SRC_ATTRIBUTE, TYPE_ATTRIBUTE, VALUE_ATTRIBUTE`

  ### Fields inherited from class org.htmlunit.html.DomNode

  `PROPERTY_ELEMENT, READY_STATE_COMPLETE, READY_STATE_INTERACTIVE, READY_STATE_LOADED, READY_STATE_LOADING, READY_STATE_UNINITIALIZED`

  ### Fields inherited from interface org.w3c.dom.Node

  `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final String`
  `getAlignAttribute()`
  Returns the value of the attribute `align`.
  `final String`
  `getArchiveAttribute()`
  Returns the value of the attribute `archive`.
  `final String`
  `getBorderAttribute()`
  Returns the value of the attribute `border`.
  `final String`
  `getClassIdAttribute()`
  Returns the value of the attribute `classid`.
  `final String`
  `getCodebaseAttribute()`
  Returns the value of the attribute "codebase".
  `final String`
  `getCodeTypeAttribute()`
  Returns the value of the attribute "codetype".
  `final String`
  `getDataAttribute()`
  Returns the value of the attribute `data`.
  `final String`
  `getDeclareAttribute()`
  Returns the value of the attribute `declare`.
  `HtmlElement.DisplayStyle`
  `getDefaultStyleDisplay()`
  INTERNAL API - SUBJECT TO CHANGE AT ANY TIME - USE AT YOUR OWN RISK.
  Returns the default display style.
  `final String`
  `getHeightAttribute()`
  Returns the value of the attribute `height`.
  `final String`
  `getHspaceAttribute()`
  Returns the value of the attribute `hspace`.
  `final String`
  `getNameAttribute()`
  Returns the value of the attribute `name`.
  `final String`
  `getStandbyAttribute()`
  Returns the value of the attribute `standby`.
  `final String`
  `getTabIndexAttribute()`
  Returns the value of the attribute `tabindex`.
  `final String`
  `getTypeAttribute()`
  Returns the value of the attribute `type`.
  `final String`
  `getUseMapAttribute()`
  Returns the value of the attribute `usemap`.
  `final String`
  `getVspaceAttribute()`
  Returns the value of the attribute `vspace`.
  `final String`
  `getWidthAttribute()`
  Returns the value of the attribute `width`.
  `boolean`
  `isCustomErrorValidityState()`
  `boolean`
  `isValid()`
  Returns whether this element satisfies all form validation constraints set.
  `boolean`
  `isValidValidityState()`
  `void`
  `onAllChildrenAddedToPage(boolean postponed)`
  Initialize the clsid.
  `void`
  `setCustomValidity(String message)`
  Sets the custom validity message for the element to the specified message.
  `boolean`
  `willValidate()`

  ### Methods inherited from class org.htmlunit.html.HtmlElement

  `acceptChar, addHtmlAttributeChangeListener, appendChildIfNoneExists, checkChildHierarchy, cloneNode, detach, doType, doType, fireHtmlAttributeAdded, fireHtmlAttributeRemoved, fireHtmlAttributeReplaced, getCanonicalXPath, getElementsByAttribute, getEnclosingElement, getEnclosingForm, getEnclosingFormOrDie, getLangAttribute, getNodeName, getOnClickAttribute, getOnDblClickAttribute, getOneHtmlElementByAttribute, getOnKeyDownAttribute, getOnKeyPressAttribute, getOnKeyUpAttribute, getOnMouseDownAttribute, getOnMouseMoveAttribute, getOnMouseOutAttribute, getOnMouseOverAttribute, getOnMouseUpAttribute, getSrcAttributeNormalized, getTabIndex, getTextDirectionAttribute, getXmlLangAttribute, handles, hasEventHandlers, isAltPressed, isAttributeCaseSensitive, isCtrlPressed, isDisplayed, isHidden, isOptional, isRequired, isRequiredSupported, isShiftPressed, isSubmittableByEnter, notifyAttributeChangeListeners, removeAttribute, removeChild, removeHtmlAttributeChangeListener, setAttributeNode, setAttributeNS, setHidden, setHidden, setOwningForm, setRequired, type, type, type, type, typeDone`

  ### Methods inherited from class org.htmlunit.html.DomElement

  `blur, click, click, click, click, click, dblClick, dblClick, doClickFireChangeEvent, doClickFireClickEvent, doClickStateUpdate, fireEvent, fireEvent, focus, getAttribute, getAttributeDirect, getAttributeNode, getAttributeNodeNS, getAttributeNS, getAttributes, getAttributesMap, getChildElementCount, getChildElements, getElementsByTagName, getElementsByTagNameNS, getEventTargetElement, getFirstElementChild, getId, getLastElementChild, getNodeType, getSchemaTypeInfo, getStaticElementsByTagName, getStyleElement, getStyleElementCaseInSensitive, getStyleMap, getTagName, hasAttribute, hasAttributeNS, hasAttributes, isDisabledElementAndDisabled, isEmptyXmlTagExpanded, isMouseOver, isStateUpdateFirst, matches, mouseDown, mouseDown, mouseMove, mouseMove, mouseOut, mouseOut, mouseOver, mouseOver, mouseUp, mouseUp, preventDefault, printOpeningTagContentAsXml, printXml, propagateClickStateUpdateToParent, removeAttributeNode, removeAttributeNS, removeFocus, removeStyleAttribute, replaceStyleAttribute, rightClick, rightClick, setAttribute, setAttributeNodeNS, setAttributeNS, setDefaults, setId, setIdAttribute, setIdAttributeNode, setIdAttributeNS, setInnerHtml, setNodeValue, toString, writeStyleToElement`

  ### Methods inherited from class org.htmlunit.html.DomNamespaceNode

  `getLocalName, getLowercaseName, getNamespaceURI, getPrefix, getQualifiedName, processImportNode, setPrefix`

  ### Methods inherited from class org.htmlunit.html.DomNode

  `addCharacterDataChangeListener, addDomChangeListener, appendChild, asNormalizedText, asXml, basicRemove, closest, compareDocumentPosition, fireCharacterDataChanged, fireNodeAdded, fireNodeDeleted, getAncestors, getBaseURI, getByXPath, getByXPath, getChildNodes, getChildren, getDescendants, getDomElementDescendants, getEndColumnNumber, getEndLineNumber, getFeature, getFirstByXPath, getFirstByXPath, getFirstChild, getHtmlElementDescendants, getHtmlPageOrNull, getIndex, getLastChild, getNextElementSibling, getNextSibling, getNodeValue, getOwnerDocument, getPage, getParentNode, getPreviousElementSibling, getPreviousSibling, getReadyState, getScriptableObject, getSelectorList, getStartColumnNumber, getStartLineNumber, getTextContent, getUserData, getVisibleText, hasChildNodes, hasFeature, insertBefore, insertBefore, isAncestorOf, isAncestorOfAny, isAttachedToPage, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, mayBeDisplayed, normalize, notifyIncorrectness, onAddedToDocumentFragment, onAddedToPage, parseHtmlSnippet, printChildrenAsXml, querySelector, querySelectorAll, quietlyRemoveAndMoveChildrenTo, remove, removeAllChildren, removeCharacterDataChangeListener, removeChild, removeDomChangeListener, replace, replaceChild, setEndLocation, setParentNode, setReadyState, setScriptableObject, setStartLocation, setTextContent, setUserData`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.w3c.dom.Node

  `appendChild, compareDocumentPosition, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setPrefix, setTextContent, setUserData`

  ### Methods inherited from interface org.htmlunit.html.ValidatableElement

  `hasBadInputValidityState, hasPatternMismatchValidityState, hasRangeOverflowValidityState, hasRangeUnderflowValidityState, hasTypeMismatchValidityState, isStepMismatchValidityState, isTooLongValidityState, isTooShortValidityState, isValueMissingValidityState`

- ## Field Details

  - ### TAG_NAME

    public static final String TAG_NAME
    The HTML tag represented by this element.
    See Also:
      - Constant Field Values

- ## Method Details

  - ### getDeclareAttribute

    public final String getDeclareAttribute()
    Returns the value of the attribute `declare`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `declare` or an empty string if that attribute isn't defined.

  - ### getClassIdAttribute

    public final String getClassIdAttribute()
    Returns the value of the attribute `classid`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `classid` or an empty string if that attribute isn't defined.

  - ### getCodebaseAttribute

    public final String getCodebaseAttribute()
    Returns the value of the attribute "codebase". Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute "codebase" or an empty string if that attribute isn't defined.

  - ### getDataAttribute

    public final String getDataAttribute()
    Returns the value of the attribute `data`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `data` or an empty string if that attribute isn't defined.

  - ### getTypeAttribute

    public final String getTypeAttribute()
    Returns the value of the attribute `type`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `type` or an empty string if that attribute isn't defined.

  - ### getCodeTypeAttribute

    public final String getCodeTypeAttribute()
    Returns the value of the attribute "codetype". Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute "codetype" or an empty string if that attribute isn't defined.

  - ### getArchiveAttribute

    public final String getArchiveAttribute()
    Returns the value of the attribute `archive`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `archive` or an empty string if that attribute isn't defined.

  - ### getStandbyAttribute

    public final String getStandbyAttribute()
    Returns the value of the attribute `standby`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `standby` or an empty string if that attribute isn't defined.

  - ### getHeightAttribute

    public final String getHeightAttribute()
    Returns the value of the attribute `height`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `height` or an empty string if that attribute isn't defined.

  - ### getWidthAttribute

    public final String getWidthAttribute()
    Returns the value of the attribute `width`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `width` or an empty string if that attribute isn't defined.

  - ### getUseMapAttribute

    public final String getUseMapAttribute()
    Returns the value of the attribute `usemap`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `usemap` or an empty string if that attribute isn't defined.

  - ### getNameAttribute

    public final String getNameAttribute()
    Returns the value of the attribute `name`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `name` or an empty string if that attribute isn't defined.

  - ### getTabIndexAttribute

    public final String getTabIndexAttribute()
    Returns the value of the attribute `tabindex`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `tabindex` or an empty string if that attribute isn't defined.

  - ### getAlignAttribute

    public final String getAlignAttribute()
    Returns the value of the attribute `align`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `align` or an empty string if that attribute isn't defined.

  - ### getBorderAttribute

    public final String getBorderAttribute()
    Returns the value of the attribute `border`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `border` or an empty string if that attribute isn't defined.

  - ### getHspaceAttribute

    public final String getHspaceAttribute()
    Returns the value of the attribute `hspace`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `hspace` or an empty string if that attribute isn't defined.

  - ### getVspaceAttribute

    public final String getVspaceAttribute()
    Returns the value of the attribute `vspace`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `vspace` or an empty string if that attribute isn't defined.

  - ### onAllChildrenAddedToPage

    public void onAllChildrenAddedToPage(boolean postponed)
    Initialize the clsid. Lifecycle method invoked after a node and all its children have been added to a page, during parsing of the HTML. Intended to be overridden by nodes which need to perform custom logic after they and all their child nodes have been processed by the HTML parser. This method is not recursive, and the default implementation is empty, so there is no need to call `super.onAllChildrenAddedToPage()` if you implement this method.
    Overrides:
      `onAllChildrenAddedToPage` in class `DomNode`
    Parameters:
      `postponed` - whether to use `PostponedAction` or no

  - ### getDefaultStyleDisplay

    public HtmlElement.DisplayStyle getDefaultStyleDisplay()
    INTERNAL API - SUBJECT TO CHANGE AT ANY TIME - USE AT YOUR OWN RISK.
    Returns the default display style.
    Overrides:
      `getDefaultStyleDisplay` in class `HtmlElement`
    Returns:
      the default display style

  - ### isValid

    public boolean isValid()
    Returns whether this element satisfies all form validation constraints set.
    Overrides:
      `isValid` in class `HtmlElement`
    Returns:
      whether this element satisfies all form validation constraints set

  - ### willValidate

    public boolean willValidate()
    Specified by:
      `willValidate` in interface `ValidatableElement`
    Returns:
      whether the element is a candidate for constraint validation

  - ### setCustomValidity

    public void setCustomValidity(String message)
    Sets the custom validity message for the element to the specified message.
    Specified by:
      `setCustomValidity` in interface `ValidatableElement`
    Parameters:
      `message` - the new message

  - ### isCustomErrorValidityState

    public boolean isCustomErrorValidityState()
    Specified by:
      `isCustomErrorValidityState` in interface `ValidatableElement`
    Returns:
      a boolean value indicating whether the element's custom validity message has been set to a non-empty string by calling the element's setCustomValidity() method.

  - ### isValidValidityState

    public boolean isValidValidityState()
    Specified by:
      `isValidValidityState` in interface `ValidatableElement`
    Returns:
      true if the element meets all its validation constraints, and is therefore considered to be valid, or false if it fails any constraint. If true, the element matches the :valid CSS pseudo-class; the :invalid CSS pseudo-class otherwise.